//icaclient/develop/main/UKH/NetClient/main/linux/obj.h264/FFDecode.h#5 - edit change 271728 (ktext)
/************************************************************************************
 *
 *   FFDecode.h
 *
 *   H.264 v3 interface software fallback implementation.
 *
 *   $Id: //icaclient/unix13.3/client/unix/CitrixPluginSDK/H264_sample/FFDecode.h#1 $
 *
 *   Copyright 2013-2014 Citrix Systems, Inc.  All Rights Reserved.
 *
 ************************************************************************************/


#ifndef _FF_DECODE_H_
#define _FF_DECODE_H_

#include "libavcodec/avcodec.h"
#include "libavformat/avformat.h"
#include "libswscale/swscale.h"

#define	REFERENCE_VAR(x) { x = x; }

#define H264_NAL_UNIT_DELIM_SIZE    6

#define GET_FN_ADDR(DllStruct, SymName) LOAD_FN_INT(DllStruct, SymName, DllStruct.fns.pfn_##SymName)
#define LOAD_FN_INT(DllStruct, SymName, hDll) *((PHSO)&(hDll)) = dlsym(DllStruct.dll, #SymName);

#define _PAPI	*

typedef		void*					HSO;
typedef		HSO*					PHSO;

typedef		unsigned char			BYTE;
typedef		BYTE*					PBYTE;
typedef		unsigned int			UINT32;

typedef 	void ( _PAPI PFN_av_log_set_level )(int level);

typedef 	void ( _PAPI PFN_av_register_all ) ();
typedef 	void ( _PAPI PFN_av_destruct_packet )( AVPacket* pkt );
typedef 	AVInputFormat* ( _PAPI PFN_av_find_input_format )( const char *short_name );
typedef 	int ( _PAPI PFN_av_open_input_file )( AVFormatContext **ic_ptr, const char *filename, AVInputFormat *fmt, int buf_size, AVFormatParameters *ap );
typedef 	int ( _PAPI PFN_av_find_stream_info )( AVFormatContext *ic );
typedef 	int ( _PAPI PFN_av_read_frame )( AVFormatContext* s, AVPacket* pkt );
typedef 	int ( _PAPI PFN_av_register_protocol )( URLProtocol *protocol );
typedef 	void ( _PAPI PFN_av_free )( void* ptr );
typedef 	void ( _PAPI PFN_av_close_input_file )( AVFormatContext* s );


typedef		void ( _PAPI PFN_avcodec_init ) ();
typedef		AVCodec* ( _PAPI PFN_avcodec_find_decoder ) (enum CodecID id);
typedef		int ( _PAPI PFN_avcodec_open ) (AVCodecContext *avctx, AVCodec *codec );
typedef		AVFrame* ( _PAPI PFN_avcodec_alloc_frame )();
typedef		int ( _PAPI PFN_avpicture_get_size ) (int pix_fmt, int width, int height );
typedef		int ( _PAPI PFN_avpicture_fill)( AVPicture *picture, uint8_t *ptr, int pix_fmt, int width, int height );
typedef		int ( _PAPI PFN_avcodec_decode_video ) (AVCodecContext *avctx, AVFrame *picture, int *got_picture_ptr, const uint8_t *buf, int buf_size );
typedef 	int ( _PAPI PFN_avcodec_close )( AVCodecContext* avctx );


typedef		struct SwsContext* ( _PAPI PFN_sws_getContext )( int srcW, int srcH, enum PixelFormat srcFormat,int dstW, int dstH, enum PixelFormat dstFormat,
                                  int flags, SwsFilter *srcFilter, SwsFilter *dstFilter, const double *param );
typedef		int ( _PAPI PFN_sws_scale )(struct SwsContext *context, uint8_t* srcSlice[], int srcStride[], int srcSliceY, int srcSliceH, uint8_t* dst[], int dstStride[] );


struct FFMPEGCtx
{
    AVFormatContext*	pFormatCtx;
    AVCodecContext*		pCodecCtx;
    AVCodec*         	pCodec;

    AVFrame*         	pFrameYUV;
	AVFrame*			pFrameBGRA;

	BufferContext		BufferCtx;
    AVPacket     		CtxAVPacket;

    BYTE 				ActualMagicBytes[ H264_NAL_UNIT_DELIM_SIZE ];
    int	            	VideoStreamIdx;
	SwsContext*			pImgConvCtx;
};


typedef struct _FFMPEG_FORMAT_CALL_TABLE
{
    PFN_av_register_all                 pfn_av_register_all;
    PFN_av_find_input_format            pfn_av_find_input_format;
    PFN_av_open_input_file          	pfn_av_open_input_file;
    PFN_av_find_stream_info          	pfn_av_find_stream_info;
    PFN_av_read_frame                   pfn_av_read_frame;
    PFN_av_destruct_packet              pfn_av_destruct_packet;
    PFN_av_register_protocol            pfn_av_register_protocol;
	PFN_av_free							pfn_av_free;
	PFN_av_close_input_file				pfn_av_close_input_file;
    PFN_av_log_set_level                pfn_av_log_set_level;
} FFMPEG_FORMAT_CALL_TABLE, *PFFMPEG_FORMAT_CALL_TABLE, **PPFFMPEG_FORMAT_CALL_TABLE;

typedef struct _FFMPEG_CODEC_CALL_TABLE
{
	PFN_avcodec_init				pfn_avcodec_init;
    PFN_avcodec_find_decoder		pfn_avcodec_find_decoder;
    PFN_avcodec_open        		pfn_avcodec_open;

    PFN_avcodec_alloc_frame			pfn_avcodec_alloc_frame;
    PFN_avpicture_get_size        	pfn_avpicture_get_size;

    PFN_avpicture_fill           	pfn_avpicture_fill;
    PFN_avcodec_decode_video		pfn_avcodec_decode_video;

	PFN_avcodec_close				pfn_avcodec_close;
} FFMPEG_CODEC_CALL_TABLE, *PFFMPEG_CODEC_CALL_TABLE, **PPFFMPEG_CODEC_CALL_TABLE;


typedef struct _FFMPEG_SWSCALE_CALL_TABLE
{
    PFN_sws_getContext                pfn_sws_getContext;
    PFN_sws_scale            	      pfn_sws_scale;
} FFMPEG_SWSCALE_CALL_TABLE, *PFFMPEG_SWSCALE_CALL_TABLE, **PPFFMPEG_SWSCALE_CALL_TABLE;

typedef struct _DLFFMPEG_FORMAT
{
    HSO dll;
    FFMPEG_FORMAT_CALL_TABLE fns;
}DLFFMPEG_FORMAT;

typedef struct _DLFFMPEG_CODEC
{
    HSO dll;
    FFMPEG_CODEC_CALL_TABLE fns;
} DLFFMPEG_CODEC;

typedef struct _DLFFMPEG_SWSCALE
{
    HSO dll;
    FFMPEG_SWSCALE_CALL_TABLE fns;
} DLFFMPEG_SWSCALE;

void 		ff_init( const char ICARoot [] );
void		ff_end ();

FFMPEGCtx*	ff_open_ctx ();
void		ff_close_ctx( FFMPEGCtx* pCtx );

#endif // _FF_DECODE_H_

